# -*- coding: utf-8 -*-
"""
Copyright (c) 2016 Biuro Urządzania Lasu i Geodezji Leśnej

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), 
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE.
"""


from Mapa_PU.kontroler import komunikaty
from math import sqrt
from Mapa_PU.kontroler import metody_globalne
from qgis.core import *

from Mapa_PU.model.konfiguracja import Konfiguracja
from Mapa_PU.kontroler.mapa import Mapa

class Centroid:
    """Klasa generująca centroidy"""
    #Marcin Śliwa
    def __init__(self,iface,katalogWarstw,mapa):
        self.iface=iface
        self.__warstwy=katalogWarstw
        self.__mapa=mapa
    
    def generuj_opis(self,nazwaWarstwy,nazwaWarstwyOpisowej,nazwyPol):
        try:
                                
            warstwaWejsciowaNazwa=self.__warstwy+'\\'+nazwaWarstwy+'.shp'
            warstwaWyjsciowaNazwa=self.__warstwy+'\\'+nazwaWarstwyOpisowej+'.shp'
            
            
            #Kontrola warstwy wejsciowej
            if metody_globalne.czyJestPlik(warstwaWejsciowaNazwa)==False:
                komunikaty.blad('Brak warstwy',"W katalogu Warstwy brak warstwy '%s'" % nazwaWarstwy )
                return
            
            warstwaWejsciowa=QgsVectorLayer(warstwaWejsciowaNazwa,nazwaWarstwy,"ogr")
            #spawdzenie istnienia rekordow
            if warstwaWejsciowa.liczbaRekordow()==0:
                komunikaty.blad(u'Brak obiektów',u"W warstwie '%s' nie ma żadnych obiektów" % nazwaWarstwy )
                return
            
         
            
            #Sprawdzenie istnienia wartwy wyjsciowej
            if metody_globalne.czyJestPlik(warstwaWyjsciowaNazwa)==False:
                komunikaty.blad('Brak warstwy','W katalogu Warstwy brak warstwy '+nazwaWarstwyOpisowej )
                return
            #kontrola warstwy wyjsciowej
            warstwaWyjsciowa=QgsVectorLayer(warstwaWyjsciowaNazwa,nazwaWarstwyOpisowej,"ogr")
                                    
            if warstwaWyjsciowa.liczbaRekordow()>0:
               nazwa=u'oddziałów' if nazwaWarstwyOpisowej=='OP_ODDZ' else u'pododdziałów'
               if komunikaty.pytanie_usun_anuluj(u'Generuj lokalizację opisów %s ' % nazwa,u'Czy usunąć obiekty z warstwy %s ?' % nazwaWarstwyOpisowej)==1:
                   return
               else:
                   #Usuniecie wszystkich rekordow rekordow
                   warstwaWyjsciowa.usunWszystkieRekordy()
                   
            
            #generowanie
            self.centroidy(warstwaWejsciowa,warstwaWyjsciowa,nazwyPol)
                     
            #Komunikat o zakonczeniu generowania
            komunikaty.informacja(u"Koniec", u"Zakończono tworzenie warstwy '%s'" % nazwaWarstwyOpisowej)
            #dodanie warstwy do mapy jeżeli będzie taka potrzeba
            #self.__mapa.zaladujWarstwe(QgsVectorLayer(warstwaWyjsciowaNazwa,nazwaWarstwyOpisowej,"ogr"))
            self.__mapa.odswierzMape()
        except Exception as e:
            raise e
            #komunikaty.blad_systemowy(e)
    
    def centroidy(self,warstwa,warstwaWyjsciowa,nazwyPol):
        """Grneruje centroidy
        :param warstwa: warstwa wejsciowa
        :warstwaOpisowa: nazwa warstwy wyjsciowej
        :param nazwyPol: lista pól do przepiasnia z warstwy źródłowej 
        """
        try:
            vprovider = warstwa.dataProvider()
            
            #writer = QgsVectorFileWriter(warstwaWyjsciowaNazwa, 'UTF-8', vprovider.fields(), QGis.WKBPoint, vprovider.crs())
            obiektWejsciowy = QgsFeature()
            centroid = QgsFeature(warstwaWyjsciowa.fields())
            
            obiektyWejsciowe = warstwa.getFeatures()
            nElement = 0
            nError = 0
            for obiektWejsciowy in obiektyWejsciowe:
                nElement += 1
                geomWejsciowa = obiektWejsciowy.geometry()
               
                if geomWejsciowa.isMultipart():
                    # find largest part in case of multipart
                    maxarea = 0
                    tmpGeom = QgsGeometry()
                    for part in geomWejsciowa.asGeometryCollection():
                        area = part.area()
                        if area > maxarea:
                            tmpGeom = part
                            maxarea = area
                    geomWejsciowa = tmpGeom
                                
                geometria = geomWejsciowa.centroid()
                if not geomWejsciowa.contains(geometria):
                    # punkt poza poligonem
                    obszar = geomWejsciowa.boundingBox()
                    horyzont = QgsGeometry.fromPolyline([QgsPoint(obszar.xMinimum(), geometria.asPoint()[1]), QgsPoint(obszar.xMaximum(), geometria.asPoint()[1])])
                    linia = horyzont.intersection(geomWejsciowa)
                    if linia is None:
                        # skip invalid geometry
                        QgsMessageLog.logMessage(u"Dla obiektu '%d' nie można ustawić centroidu" % nElement)
                        nError += 1
                        continue
                    elif linia.isMultipart():
                        # find longest intersection
                        mlinia = linia.asMultiPolyline()
                        l = 0
                        for i in range(len(mlinia)):
                            d = sqrt((mlinia[i][0][0] - mlinia[i][1][0])**2 + (mlinia[i][0][1] - mlinia[i][1][1])**2)
                            if d > l:
                                l = d
                                x = (mlinia[i][0][0] + mlinia[i][1][0]) / 2.0
                                y = (mlinia[i][0][1] + mlinia[i][1][1]) / 2.0
                    else:
                        x = (linia.vertexAt(0).x() + linia.vertexAt(1).x()) / 2.0
                        y = (linia.vertexAt(0).y() + linia.vertexAt(1).y()) / 2.0
                    geometria = QgsGeometry.fromPointXY(QgsPointXY(x, y))
                    
                
                #ustawienie atrybutów centroidu
                for nazwa in nazwyPol:
                    wartosc=obiektWejsciowy.attributes()[warstwa.idxPola(nazwa)]
                    centroid.setAttribute(nazwa,wartosc)
                
                
                centroid.setGeometry(geometria)
                
                #dodanie obiektu do zapisu
                warstwaWyjsciowa.dataProvider().addFeatures([centroid])
               

        except Exception as e:
            raise e
            #komunikaty.blad_systemowy(e)

    